%% (c) 2000 Dale Gerdemann, Gertjan van Noord; available under GPL
%%
%% This is an alternative implementation of syllabification in
%% Optimality Theory (compare with Karttunen, 'The Proper Treatment of 
%% Optimality in Computational Phonology'.
%%
%% variant of matching.pl which implements Eisner's `directional'
%% constraint checking

:- multifile macro/2.

:- ensure_loaded(utils).

macro(add_violation, 
      {output : [], ? - output}*
                     o
           [? *, []:'@@', ~ [@, ? *]]
                     o
	    [ ? *, '@@' : @ , {?, @ : [], [] : @}* ]
                     o
      {[] : output, ? - output}*
     ).


macro(Input oo _ :: Constraint, Input oo Constraint).
macro(Input oo Constraint,pragma([V-(Input o mark_ot_constraint(Constraint,@))],
                    V 
                    o
             ~ range(  V
		       o
		  add_violation
		    )
                    o
             { @ : [],? -  @ }*		 
		    )).

