/* This file is generated automatically by FSA Utilities.
 * (c) 1993 - 2000 Gertjan van Noord RUG
 * More information from http://www.let.rug.nl/~vannoord/Fsa/
 * 
 * The representation of the finite-automaton is
 * similar to the technique explained on page 43 (table
 * 4.2) of Jan Daciuk's dissertation `Incremental
 * Construction of Finite-State Automata and Transducers
 * and their use in the Natural Language Processing'.
 * Politechnika Gdanska, 1998, except that instead of the number
 * of transitions we have a boolean flag indicating for each
 * line whether that line is the last transition for the current
 * state.
 */



import FSA.*;
public class a {
    private static final Transition tA [] = {
        /* sink                                        */
        new Transition(       0,   true,  false,      0),
        /* start state                                 */
        new Transition(       0,  false,   true,      2),
        /* normal transitions                          */
        new Transition(      97,  false,  false,      5),
        new Transition(      98,   true,  false,      6),
        new Transition(      98,   true,  false,      6),
        new Transition(      97,   true,   true,      2),
        new Transition(      98,   true,   true,      4),
    };

    public boolean accepts(String in)
    {
	return DFA.accepts(tA,in);
    }

    public void accepts_all ()
    {
	DFA.accepts_all(tA);
    }

 

    public static void main(String argv[]) {
	(new a()).accepts_all();
    }
}

