/* This file is generated automatically by FSA Utilities.
 * (c) 1993 - 2000 Gertjan van Noord RUG
 * More information from http://www.let.rug.nl/~vannoord/Fsa/
 * 
 * The representation of the finite-automaton is
 * similar to the technique explained on page 43 (table
 * 4.2) of Jan Daciuk's dissertation `Incremental
 * Construction of Finite-State Automata and Transducers
 * and their use in the Natural Language Processing'.
 * Politechnika Gdanska, 1998, except that instead of the number
 * of transitions we have a boolean flag indicating for each
 * line whether that line is the last transition for the current
 * state.
 */



import FSA.*;
public class b {
    private static final TransitionT tA [] = {
        /* sink                                        */
        new TransitionT(       0,   true,  false,      0,"",""),
        /* start state                                 */
        new TransitionT(       0,  false,   true,      2,"",""),
        /* normal transitions                          */
        new TransitionT(      97,  false,  false,      4,"bb",""),
        new TransitionT(      98,   true,  false,      5,"aa",""),
        new TransitionT(      97,   true,   true,      2,"",""),
        new TransitionT(      98,   true,   true,      6,"",""),
        new TransitionT(      98,   true,  false,      5,"aa",""),
    };

    public String transduces(String in)
    {
	return DFA.transduces(tA,"",in);
    }

    public void transduces_all ()
    {
	DFA.transduces_all(tA,"");
    }

 


    public static void main(String argv[]) {
	(new b()).transduces_all();
    }
}

